/*

         
============================================================================

      -  
   - .   ,   
,       ,  
   .

         
   32.

     (full duplex) 
,     .

*/





#pragma warning (disable: 4115 4201 4214 4514)


#if _DEBUG

  #pragma warning (disable: 4505)

#endif


#define STRICT

#include <windows.h>            //   Windows
#include <commctrl.h>           //    

#include <stdlib.h>             //    C/C++


#include "resource.h"           //  







//
// #########################################################################
//
//  
//
// #########################################################################
//





#define SampleRate 44100        //  
#define BitsPerSample 16        //  
#define Channels 2              //  

#define BufferMS 500            //     
#define Buffers 4               //  


#define DefDelay 100            //    





//
// #########################################################################
//
// 
// 
// #########################################################################
//





enum {                          //   

  WMU_StopCompleted = WM_USER + 1024, //  

};





//
// #########################################################################
//
// 
// 
// #########################################################################
//





#ifdef _DEBUG

  #include <stdio.h>

  #define Debug DebugPrintF /*       */ 

#else

  #define Debug /##/

#endif


#define UNREF(x) (void)(x)





//
// #########################################################################
//
// 
// 
// #########################################################################
//





static HINSTANCE GlobalInst;    //   





//
// #########################################################################
//
// 
//
// #########################################################################
//


HWAVEIN In;                   //   
HWAVEOUT Out;                 //   

WAVEFORMATEX Format;          //   

UINT BytesPerSample;          //    
UINT BufferSize;              //     
UINT AllocatedBuffers;        //   
UINT InBuffers;               //     In
UINT OutBuffers;              //     Out

char *HoldBuffer;             //    
char *DelayBuffer;            //    

UINT Delay = DefDelay;        //   

DWORD Flags;                  //  

  #define SF_Running 1        //  
  #define SF_StopReq 2        //  
  #define SF_OutStarted 4     //   


HANDLE WorkerThreadHandle;    //   
DWORD WorkerThreadId;         //   



HWND DlgWin;                  //   

DWORD DefPrioClass;           //     

DWORD StartTime;              //    





//
// #########################################################################
//
// 
//
// #########################################################################
//





//
//   
// =======================
//

#ifdef _DEBUG

static void DebugPrintF (char *Format, ...) {

  char Str [256];
  va_list Args;
  int Len;

  sprintf (
    Str,
    "%06u: %n",
    (timeGetTime () - StartTime) % 1000000,
    &Len
  );

  va_start (Args, Format);
  vsprintf (Str + Len, Format, Args);
  va_end (Args);
  strcat (Str, "\r\n");
  OutputDebugString (Str);

}

#endif





//
//      
// ======================================================
//

LONG DlgMsg (int Id, UINT Msg, LPARAM lp, WPARAM wp) {

  return SendDlgItemMessage (DlgWin, Id, Msg, lp, wp);

}





//
//    
// ==========================
//

void Error (char *Text) {

  MessageBox (NULL, Text, "Error", MB_ICONERROR | MB_OK);

}





//
//   
// ==========================
//

void StopDevices (void) {

  Flags |= SF_StopReq;

  waveInReset (In);
  waveOutReset (Out);

}





//
//  
// ====================
//

void CloseDevices (void) {

  if (In) {

    waveInClose (In);

    In = NULL;

  }

  if (Out) {

    waveOutClose (Out);

    Out = NULL;

  }

  if (HoldBuffer) {

    GlobalFree ((HGLOBAL)HoldBuffer);

  }

  if (DelayBuffer) {

    GlobalFree ((HGLOBAL)DelayBuffer);

  }

}






//
//   
// =============================
//


void ReleaseBuffer (WAVEHDR *Hdr) {

  GlobalFree ((HGLOBAL)Hdr->lpData);
  LocalFree ((HLOCAL)Hdr);

  if (!--AllocatedBuffers) {    //    

    //
    //      
    //

    PostThreadMessage (WorkerThreadId, WM_QUIT, 0, 0);

  }

}





//
//     
// ====================================
//


int OpenDevices (void) {

  MMRESULT Res;
  
  In = NULL;
  Out = NULL;
  AllocatedBuffers = 0;

  BytesPerSample = (BitsPerSample + 7) / 8;

  Format.wFormatTag = WAVE_FORMAT_PCM;
  Format.nChannels = Channels;
  Format.wBitsPerSample = BitsPerSample;
  Format.nBlockAlign = (WORD)(Channels * BytesPerSample);
  Format.nSamplesPerSec = SampleRate;
  Format.nAvgBytesPerSec = Format.nSamplesPerSec * Format.nBlockAlign;
  Format.cbSize = 0;


  //
  //   ,  -  
  //

  for (int DevType = 0; DevType < 2; DevType++) {


    //
    //      
    //

    int  DevN = DlgMsg ((DevType? IDC_WaveOut : IDC_WaveIn), CB_GETCURSEL, 0, 0);


    //
    //       
    //  - Wave Mapper
    //

    typedef MMRESULT (WINAPI *OpenFuncPtr) (HWAVE *, UINT, LPWAVEFORMATEX, DWORD, DWORD, DWORD);


    //
    //    
    //

    OpenFuncPtr OpenFunc = (DevType? (OpenFuncPtr)waveOutOpen : (OpenFuncPtr)waveInOpen);


    //
    //    ,   
    //

    Res = OpenFunc (
      DevType? (HWAVE *)&Out : (HWAVE *)&In,
      DevN - 1,
      &Format,
      (DWORD)WorkerThreadId,
      0,
      CALLBACK_THREAD
    );


    if (Res != MMSYSERR_NOERROR) {

      char Str [40 + MAXPNAMELEN];
      
      strcpy (Str, "   ");

      //
      //     
      //

      DlgMsg (
        (DevType? IDC_WaveOut : IDC_WaveIn),
        WM_GETTEXT,
        MAXPNAMELEN,
        (DWORD)(Str + strlen (Str))
      );


      //
      //    
      //

      Error (Str);

      break;

    }

  }

  if (Res != MMSYSERR_NOERROR) {

    return FALSE;

  }


  //
  //      ""   
  //

  waveOutPause (Out);
  

  //
  //      
  //

  BufferSize = (Format.nSamplesPerSec * BufferMS / Buffers + 500) / 1000;

  if (!BufferSize) {

    BufferSize++;

  }


  //
  //      
  //

  BufferSize *= Format.nBlockAlign;


  Debug ("Buffer size - %u", BufferSize);


  //
  //      
  //

  HoldBuffer = (char *)GlobalAlloc (GMEM_FIXED, BufferSize);
  DelayBuffer = (char *)GlobalAlloc (GPTR, BufferSize);

  if (!HoldBuffer || !DelayBuffer) {

    return FALSE;

  }


  if (BytesPerSample == 1) {

    //
    //      8- 
    //

    memset (DelayBuffer, 0x80, BufferSize);

  }


  //
  //      ,   
  //     
  //

  for (int N = Buffers; N > 0; N--) {

    char *Buf = (char *)GlobalAlloc (GMEM_FIXED, BufferSize);
    WAVEHDR *Hdr = (WAVEHDR *)LocalAlloc (LMEM_FIXED, sizeof (*Hdr));

    if (Buf && Hdr) {

      //
      //   
      //

      Hdr->lpData = Buf;
      Hdr->dwBufferLength = BufferSize;
      Hdr->dwFlags = 0;
      Hdr->dwLoops = 0;
      Hdr->dwUser = 0;


      //
      //    
      //

      waveInPrepareHeader (In, Hdr, sizeof (*Hdr));
      Res = waveInAddBuffer (In, Hdr, sizeof (*Hdr));

    }

    if (Buf && Hdr && Res == MMSYSERR_NOERROR) {

      AllocatedBuffers++;
      InBuffers++;

    } else {

      //
      // .   
      //

      if (HoldBuffer) {

        GlobalFree ((HGLOBAL)HoldBuffer);

      }

      if (DelayBuffer) {

        GlobalFree ((HGLOBAL)DelayBuffer);

      }

      if (Buf) {

        GlobalFree ((HGLOBAL)Buf);

      }

      if (Hdr) {

        LocalFree ((HLOCAL)Hdr);

      }

      return FALSE;

    }

  }

  return TRUE;

}





//
//      
// ==============================================
//

void ShowDelay (void) {

  char Num [10];

  itoa (Delay, Num, 10);

  DlgMsg (IDC_DelayVal, WM_SETTEXT, 0, (LPARAM)Num);

}





//
//  
// ==============
//

DWORD WINAPI WorkerThreadProc (void *Arg) {

  //
  //      
  //

  SetThreadPriority (GetCurrentThread (), THREAD_PRIORITY_TIME_CRITICAL);

  MSG Msg;

  //
  //         WM_QUIT
  //    
  //

  while (GetMessage (&Msg, NULL, 0, 0) == TRUE) {

    switch (Msg.message) {





      //
      //     
      //

      case MM_WIM_DATA: {

        WAVEHDR *Hdr = (WAVEHDR *)Msg.lParam;

        waveInUnprepareHeader (In, Hdr, sizeof (*Hdr));

        InBuffers--;

        if (Flags & SF_StopReq) {

          ReleaseBuffer (Hdr);

          break;

        }


        //
        //        
        //

        UINT DelayBlocks = (SampleRate * Delay + 500) / 1000;
        UINT DelayBytes = DelayBlocks * Format.nBlockAlign;


        if (DelayBytes < BufferSize) {


          //
          //    
          //

          memcpy (
            HoldBuffer,
            Hdr->lpData + BufferSize - DelayBytes,
            DelayBytes
          );


          //
          //       
          //

          memcpy (
            DelayBuffer + DelayBytes,
            Hdr->lpData,
            BufferSize - DelayBytes
          );


          //
          //   
          //

          char *bp = Hdr->lpData; //   
          char *dp = DelayBuffer; //   


          //
          //    8- 
          //

          DWORD Corr = (BytesPerSample == 1)? 0x80000000 : 0;

          //
          //   
          //
          //        .
          //       ; 
          //      .
          //

          for (UINT i = BufferSize / BytesPerSample; i; i--) {

            //
            //     
            //

            static DWORD Mask [] = {
              0xFF000000, 0xFFFF0000, 0xFFFFFF00, 0xFFFFFFFF
            };


            //
            //        
            //

            DWORD dv = *(DWORD *)(dp - 4 + BytesPerSample);


            //
            //     
            //

            dv &= Mask [BytesPerSample - 1];


            //
            //     
            //

            *(DWORD *)(bp - 4 + BytesPerSample) += dv + Corr;


            //
            //   
            //

            bp += BytesPerSample;
            dp += BytesPerSample;

          }


          //
          //        
          //

          memcpy (DelayBuffer, HoldBuffer, DelayBytes);


        }


        //
        //    
        //

        waveOutPrepareHeader (Out, Hdr, sizeof (*Hdr));
        waveOutWrite (Out, Hdr, sizeof (*Hdr));

        OutBuffers++;

        if (OutBuffers >= Buffers / 2 && !(Flags & SF_OutStarted)) {

          //
          //         - 
          //

          waveOutRestart (Out);
          Flags |= SF_OutStarted;

        }

        break;

      }





      //
      //      
      //

      case MM_WOM_DONE: {

        WAVEHDR *Hdr = (WAVEHDR *)Msg.lParam;

        waveOutUnprepareHeader (Out, Hdr, sizeof (*Hdr));

        OutBuffers--;

        if (Flags & SF_StopReq) {

          ReleaseBuffer (Hdr);

          break;

        }


        //
        //      
        //

        waveInPrepareHeader (In, Hdr, sizeof (*Hdr));
        waveInAddBuffer (In, Hdr, sizeof (*Hdr));

        InBuffers++;

        break;

      }






    }

  }


  //
  //       -
  //

  PostMessage (DlgWin, WMU_StopCompleted, 0, 0);

  return 0;

  UNREF (Arg);

}




//
//    
// =====================================
//

BOOL CALLBACK DialogProc (HWND Win, UINT Msg, WPARAM wp, LPARAM lp) {

  DlgWin = Win;

  switch (Msg) {





    //
    //   
    // ==============================
    //

    case WM_INITDIALOG: {

      int NumWaveDevs;
      int i;

      DefPrioClass = GetPriorityClass (GetCurrentProcess ());


      //
      //      
      //

      DlgMsg (
        IDC_Delay,
        TBM_SETRANGE,
        TRUE,
        MAKELONG (1, BufferMS / Buffers - 1)
      );

      DlgMsg (
        IDC_Delay,
        TBM_SETPOS,
        TRUE,
        Delay
      );

      ShowDelay ();


      //
      //    ,   Wave Mapper
      //

      NumWaveDevs = waveInGetNumDevs ();
      
      for (i = 0; i < NumWaveDevs + 1; i++) {
        
        WAVEINCAPS DevCaps;

        waveInGetDevCaps (i - 1, &DevCaps, sizeof (DevCaps));
        DlgMsg (IDC_WaveIn,  CB_ADDSTRING,  0, (LPARAM)DevCaps.szPname);
        
      }

      DlgMsg (IDC_WaveIn, CB_SETCURSEL, 0, 0);


      //
      //    ,   Wave Mapper
      //

      NumWaveDevs = waveOutGetNumDevs ();
      
      for (i = 0; i < NumWaveDevs + 1; i++) {
        
        WAVEOUTCAPS DevCaps;

        waveOutGetDevCaps (i - 1, &DevCaps, sizeof (DevCaps));
        DlgMsg (IDC_WaveOut, CB_ADDSTRING, 0, (LPARAM)DevCaps.szPname);
        
      }

      DlgMsg (IDC_WaveOut, CB_SETCURSEL, 0, 0);


      return TRUE;

    }





    //
    //   Windows
    // ===========================
    //

    case WM_COMMAND: {

      UINT CtrlId = LOWORD (wp);
      UINT CtrlMsg = HIWORD (wp);
      
      switch (CtrlId) {
        

        //
        //     -     
        // =================================================================
        //

        case IDCANCEL: {

          if (!(Flags & SF_Running)) {

            EndDialog (DlgWin, 0);
            return TRUE;

          }

          break;

        }
        




        //
        //   /
        // ===============================
        //

        case IDC_StartStop: {

          //
          //     
          //

          EnableWindow (GetDlgItem (DlgWin, IDC_StartStop), 0);

          if (!(Flags & SF_Running)) { // 

            int Success;

            InBuffers = 0;
            OutBuffers = 0;

            StartTime = timeGetTime ();

            timeBeginPeriod (1); //   - 1 


            //
            //   
            //

            SetPriorityClass (GetCurrentProcess (), HIGH_PRIORITY_CLASS);


            //
            //   
            //

            WorkerThreadHandle = CreateThread (
              NULL,
              0,
              WorkerThreadProc,
              NULL,
              0,
              &WorkerThreadId
            );


            //
            //   
            //

            Success = OpenDevices ();

            if (Success) {

              if (waveInStart (In) == MMSYSERR_NOERROR) {

                //
                //   -    
                //

                DlgMsg (IDC_StartStop, WM_SETTEXT, 0, (LPARAM)"");

                Flags |= SF_Running;

              } else {

                CloseDevices ();
                Error ("  ");

              }

            }

          } else { // 

            StopDevices ();

            timeEndPeriod (1);  //   

          }

          if (!(Flags & SF_StopReq)) {

            //
            //     -  
            //

            EnableWindow (GetDlgItem (DlgWin, IDC_StartStop), 1);

          }

          break;
        
        }

      }

      break;

    }





    //
    //    
    // ====================================
    //

    case WM_HSCROLL: {

      switch (LOWORD (wp)) { //   
      
        case TB_PAGEUP:
        case TB_PAGEDOWN:
        case TB_THUMBTRACK: {

          Delay = DlgMsg (IDC_Delay, TBM_GETPOS, 0, 0);

          ShowDelay ();

        }

      }

      break;

    }





    //
    //   
    // ===========================
    //

    case WMU_StopCompleted: {
    
      timeEndPeriod (1);  //   


      //
      //      
      //

      CloseHandle (WorkerThreadHandle);

      WorkerThreadId = 0;
      WorkerThreadHandle = NULL;

      CloseDevices ();


      //
      //      
      //

      SetPriorityClass (GetCurrentProcess (), DefPrioClass);

      Flags &= ~(SF_Running | SF_StopReq | SF_OutStarted);


      //
      //       
      //

      DlgMsg (IDC_StartStop, WM_SETTEXT, 0, (LPARAM)"");

      EnableWindow (GetDlgItem (DlgWin, IDC_StartStop), 1);


      break;

    }  





  }

  return FALSE;

  UNREF (lp);

}
      

//
//   Windows
// ========================
//

int WINAPI WinMain (
  HINSTANCE Instance,
  HINSTANCE PrevInstance,
  LPSTR Cmd,
  int CmdShow
) {

  int Result;
  

  //
  //     
  //

  InitCommonControls ();


  GlobalInst = Instance;

  In = NULL;
  Out = NULL;
  AllocatedBuffers = 0;
  InBuffers = OutBuffers = 0;
  Flags = 0;
  WorkerThreadHandle = NULL;
  WorkerThreadId = 0;


  //
  //   
  //

  Result = DialogBox (
    Instance, 
    MAKEINTRESOURCE (IDD_RptDialog),
    HWND_DESKTOP,
    DialogProc
  );


  return Result;

  UNREF (PrevInstance);
  UNREF (Cmd);
  UNREF (CmdShow);

}
